﻿local _CommonFunctions, StoneGateSetPrefix, CommonWindowPrefix = ...

_CommonFunctions:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")
_CommonFunctions:registerEnumValue ("BUILDING_PART_TYPE", "DECORATION")
_optionAccessNodeType = "MAJOR" -- "STONEGATEACCESS"
_CommonFunctions:registerEnumValue ("ATTACH_NODE_TYPE", _optionAccessNodeType)

-- Register the stone gate set monument
function configureMaterialSet(_color, _material, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _defaultMaterial)
    function configureWindowRoofMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureWindowWallMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureWindowFrameMaterial(_core)
        if _defaultMaterial then
            return CommonWindowPrefix .. "_" .. _core .. "_" .. _colorFrame .. "_FRAME_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFrame .. "_FRAME_MATERIAL"
        end
    end
    function configureSimpleRoofMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configurePointedRoofMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _color .. "_POINTED_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureRoofOverMachicolationsMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_" .. _color .. "_" .. _material .. "_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _color .. "_" .. _material .. "_MATERIAL"
        end
    end
    function configureWallMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
        end
    end
    function configureFrameMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorFrame .. "_FRAME_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFrame .. "_FRAME_MATERIAL"
        end
    end
    function configureCrenellationMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorCrenellation .. "_CRENELLATION_MATERIAL"
        end
    end
    function configureBasementMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorBasement .. "_BASEMENT_MATERIAL"
        end
    end
    function configureFloorGroundMaterial(_core)
        if _defaultMaterial then
            return StoneGateSetPrefix .. "_" .. _core .. "_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        else
            return CommonWindowPrefix .. "_DECORATION_" .. _colorFloorGround .. "_FLOOR_GROUND_MATERIAL"
        end
    end
    
    return  {
                SetName = StoneGateSetPrefix .. "_" .. _color .. "_" .. _material .. "_" .. _colorWall,
                MaterialList = {
                    -- from Windows Decoration mod
                    configureWindowRoofMaterial("STONE_WINDOW"),
-- currently not used                    configureWindowRoofMaterial("WOODEN_DOOR"),
                    configureWindowRoofMaterial("WOODEN_WINDOW"),
                    configureWindowRoofMaterial("WOODEN_ENTRANCE"),
                    configureWindowWallMaterial("STONE_DECORATION"),
                    configureWindowWallMaterial("STONE_BUTTRESS"),
                    configureWindowFrameMaterial("STONE_DECORATION"),
                    configureWindowFrameMaterial("STONE_DECORATION3"),
                    configureWindowFrameMaterial("STONE_DOORS"),
                    configureWindowFrameMaterial("STAINED_GLASS"),
                    -- simple roofs
                    configureSimpleRoofMaterial("MAIN"),
                    configureSimpleRoofMaterial("KEEP"),
                    configureSimpleRoofMaterial("SST"),
                    configureSimpleRoofMaterial("SGATE"),
                    configureSimpleRoofMaterial("A45"),
                    configureSimpleRoofMaterial("OTOWER"),
                    configureSimpleRoofMaterial("CIRCULAR"),
                    configureSimpleRoofMaterial("SCT"),
                    -- pointed roofs
                    configurePointedRoofMaterial("MAIN"),
                    configurePointedRoofMaterial("KEEP"),
                    configurePointedRoofMaterial("SST"),
                    configurePointedRoofMaterial("OTOWER"),
                    configurePointedRoofMaterial("CIRCULAR"),
                    configurePointedRoofMaterial("SCT"),
                    configurePointedRoofMaterial("SGATE"),
                    configurePointedRoofMaterial("A45"),
                    -- roofs over machicolations
                    configureRoofOverMachicolationsMaterial("MAIN"),
                    configureRoofOverMachicolationsMaterial("KEEP"),
                    configureRoofOverMachicolationsMaterial("SST"),
                    configureRoofOverMachicolationsMaterial("SGATE"),
                    configureRoofOverMachicolationsMaterial("SGATE2"),
                    configureRoofOverMachicolationsMaterial("A45"),
                    configureRoofOverMachicolationsMaterial("OTOWER"),
                    configureRoofOverMachicolationsMaterial("CIRCULAR"),
                    configureRoofOverMachicolationsMaterial("SCT"),
                    -- wall
                    configureWallMaterial("OVER_HANGING"),
                    configureWallMaterial("A45"),
                    configureWallMaterial("CIRCULAR"),
                    configureWallMaterial("KEEP"),
                    configureWallMaterial("LARGE_GATE"),
                    configureWallMaterial("MAIN"),
                    configureWallMaterial("OTOWER"),
                    configureWallMaterial("SCT"),
                    configureWallMaterial("SGATE"),
                    configureWallMaterial("SST"),
                    configureWallMaterial("RAMPART_SST"), -- wall parts from the stairs
                    configureWallMaterial("BRIDGE_SST"),
                    configureWallMaterial("DECORATIONS_PINION"),
                    configureWallMaterial("DRAWBRIDGE_A"),
                    configureWallMaterial("MACHICOLATION_KEEP"),
                    configureWallMaterial("MACHICOLATION_MAIN"),
                    configureWallMaterial("MACHICOLATION_SST"),
                    configureWallMaterial("MACHICOLATION_SGATE"),
                    configureWallMaterial("MACHICOLATION_A45"),
                    configureWallMaterial("MACHICOLATION_OTOWER"),
                    configureWallMaterial("MACHICOLATION_CIRCULAR"),
                    configureWallMaterial("MACHICOLATION_SCT"),
                    configureWallMaterial("POINTED_ROOFS_PINION"),
                    -- crenellation
                    configureCrenellationMaterial("RAMPART_A45"),
                    configureCrenellationMaterial("RAMPART_CIRCULAR"),
                    configureCrenellationMaterial("RAMPART_KEEP"),
                    configureCrenellationMaterial("RAMPART_MAIN"),
                    configureCrenellationMaterial("RAMPART_OTOWER"),
                    configureCrenellationMaterial("RAMPART_SCT"),
                    configureCrenellationMaterial("SGATE"),
                    configureCrenellationMaterial("RAMPART_SST"),
                    configureCrenellationMaterial("HOARDING_A45"),
                    configureCrenellationMaterial("HOARDING_CIRCULAR"),
                    configureCrenellationMaterial("HOARDING_OTOWER"),
                    configureCrenellationMaterial("HOARDING_S3"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S3"),
                    configureCrenellationMaterial("HOARDING_S2"),
                    configureCrenellationMaterial("HOARDING_EXTENSION_S2"),
                    configureCrenellationMaterial("HOARDING_S1"),
                    configureCrenellationMaterial("HOARDING_SGATE"),
                    configureCrenellationMaterial("HOARDING_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_KEEP"),
                    configureCrenellationMaterial("MACHICOLATION_CRENATION"),
                    configureCrenellationMaterial("MACHICOLATION_MAIN"),
                    configureCrenellationMaterial("MACHICOLATION_SST"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE"),
                    configureCrenellationMaterial("MACHICOLATION_SGATE2"),
                    configureCrenellationMaterial("MACHICOLATION_A45"),
                    configureCrenellationMaterial("MACHICOLATION_OTOWER"),
                    configureCrenellationMaterial("MACHICOLATION_CIRCULAR"),
                    configureCrenellationMaterial("MACHICOLATION_SCT"),
                    -- basement
                    configureBasementMaterial("MAIN"),
                    configureBasementMaterial("KEEP"),
                    configureBasementMaterial("OTOWER"),
                    configureBasementMaterial("CIRCULAR"),
                    configureBasementMaterial("SST"),
                    -- floor ground
                    configureFloorGroundMaterial("SST"),
                    configureFloorGroundMaterial("RAMPART_SST"), -- ground parts from the stairs
                    configureFloorGroundMaterial("BRIDGE_SST"),
                    configureFloorGroundMaterial("MACHICOLATION_SST"),
                    configureFloorGroundMaterial("KEEP"),
                    configureFloorGroundMaterial("MACHICOLATION_KEEP"),
                    configureFloorGroundMaterial("MAIN"),
                    configureFloorGroundMaterial("MACHICOLATION_MAIN"),
                    configureFloorGroundMaterial("A45"),
                    configureFloorGroundMaterial("MACHICOLATION_A45"),
                    configureFloorGroundMaterial("CIRCULAR"),
                    configureFloorGroundMaterial("MACHICOLATION_CIRCULAR"),
                    configureFloorGroundMaterial("OTOWER"),
                    configureFloorGroundMaterial("MACHICOLATION_OTOWER"),
                    configureFloorGroundMaterial("SCT"),
                    configureFloorGroundMaterial("MACHICOLATION_SCT"),
                    configureFloorGroundMaterial("SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE"),
                    configureFloorGroundMaterial("MACHICOLATION_SGATE2"),
                    configureFloorGroundMaterial("LARGE_GATE"),
                    -- frame
                    configureFrameMaterial("LARGE_GATE"),
                    configureFrameMaterial("SCT"),
                    configureFrameMaterial("SGATE"),
                    configureFrameMaterial("SST"),
                    configureFrameMaterial("DECORATIONS_DECORATION"),
                    configureFrameMaterial("DRAWBRIDGE_A"),
                    configureFrameMaterial("DRAWBRIDGE_B"),
                    configureFrameMaterial("MACHICOLATION_KEEP"),
                    configureFrameMaterial("MACHICOLATION_MAIN"),
                    configureFrameMaterial("MACHICOLATION_SST"),
                    configureFrameMaterial("MACHICOLATION_SGATE"),
                    configureFrameMaterial("MACHICOLATION_SGATE2"),
                    configureFrameMaterial("MACHICOLATION_A45"),
                    configureFrameMaterial("MACHICOLATION_OTOWER"),
                    configureFrameMaterial("MACHICOLATION_CIRCULAR"),
                    configureFrameMaterial("MACHICOLATION_SCT"),
               }
    }
end

function configureMaterialSetList(_configureMaterialSet)
    return {
            _configureMaterialSet("RED", "ROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", true), -- default material
            _configureMaterialSet("BLUE", "ROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BROWN", "ROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("GREY", "ROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("GREY2", "ROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("RED", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BLUE", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BROWN", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("YELLOW", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("GREEN", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false ),
            _configureMaterialSet("MANOR", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("MANOR2", "WROOF", "MANOR2", "BLUE", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BROWN_MONASTERY", "ROOF", "BROWN_MONASTERY", "BROWN_MONASTERY", "BROWN_MONASTERY", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BLUE_MONASTERY", "ROOF", "BLUE_MONASTERY", "BLUE_MONASTERY", "BLUE_MONASTERY", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("PURPLE_MONASTERY", "ROOF", "PURPLE_MONASTERY", "PURPLE_MONASTERY", "PURPLE_MONASTERY", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("MANOR", "WROOF", "RED_STONE", "RED_STONE", "RED_STONE", "ROSE", "WHITE_STONE", false),
            _configureMaterialSet("RED", "WROOF", "GIANT_GATE", "GIANT_GATE", "GIANT_GATE", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("STRAW", "ROOF", "WHITE_CHALK", "WHITE_CHALK", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BROWN_MONASTERY", "ROOF", "WHITE_CHALK", "WHITE_CHALK", "MANOR2", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("RED", "ROOF", "SAND_STONE", "SAND_STONE", "SAND_STONE", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("BROWN", "ROOF", "SAND_STONE", "SAND_STONE", "SAND_STONE", "WHITE", "WHITE_STONE", false),
            _configureMaterialSet("STRAW", "ROOF", "WOOD", "WHITE_CHALK", "MANOR2", "WHITE", "WOOD", false),
    }
end

function checkVersion(_mod, _modName, _name, _id, _minimalVersion)
    if (foundation.getModVersion == nil) then
        _mod:logError(_modName .. " Unknown mod version")
        return false
    end
    if not foundation.isModEnabled(_id) then
        _mod:logError(_modName .. " " .. _name .. " disabled")
        return false
    end
    if not foundation.isModLoaded(_id) then
        _mod:logWarning(_modName .. " Up the position of " .. _name .. " in the mod list of your game")
        return false
    end
    local _myVersion = foundation.getModVersion(_id)
    _mod:msgBox(_modName .. " " .. _name .. " Current version : " .. _myVersion)
    if version.cmp(_myVersion, _minimalVersion) < 0 then
        _mod:logWarning(_modName .. " Please, load at least the version " .. _minimalVersion .. " of " .. _name)
        return false
    end
    return true
end

-- Set the sandbox option
function difficultyLevel(_mod, _modName)
    if foundation.isModEnabled("8f186d4a-7b5d-4b8a-b959-43bd254ca95b") then
        _mod:log("Hello World: " .. _modName .. " sandbox mode.")
        return 0
    end
    _mod:log("Hello World: " .. _modName .. " difficulty level low by default")
    return 1
end

--------------------------------------------------------------------------
function computeElevation(_self, _initialPosition, _flagList)
    local _flags = 0
    for i, flag in ipairs(_flagList) do
        _flags = _flags + 2^flag:toNumber()
    end
    if _flags == 0 then
         _CommonFunctions:logWarning("computeElevation: _flagList empty")
         return _initialPosition[2]
    end 
    local raycastResult = {}

    -- Raycast from the building position + Y = 100
    -- to building position - y = 100
    -- only on objects with a WATER flag
    local FromPosition = { _initialPosition[1], _initialPosition[2]+100, _initialPosition[3] }
    local ToPosition = { _initialPosition[1], _initialPosition[2]-100, _initialPosition[3] }
    
    if not _self:getLevel():rayCast(FromPosition, ToPosition, raycastResult, _flags) then
         _CommonFunctions:logWarning("computeElevation: not any flag found " .. tostring(_flagList))
         return nil
    end
    return raycastResult["Position"][2] 
end



